import { ChildrenTypes } from 'misstime';
import { Directives, SourceLocation, ASTNode, ASTElement, Options, ChildrenFlags } from './types';
export declare function trimRight(str: string): string;
export declare function isWhiteSpace(charCode: number): boolean;
export declare const selfClosingTags: Record<string, true>;
export declare const textTags: Record<string, true>;
export declare const directivesMap: Record<Directives, true>;
export declare function isJSIdentifierPart(ch: number): boolean;
export declare function isJSXIdentifierPart(ch: number): boolean;
export declare function isWhiteSpaceExceptLinebreak(charCode: number): boolean;
export declare function isElementNode(node: ASTNode): node is ASTElement;
export declare function throwError(msg: string, loc: SourceLocation, source: string): never;
export declare const getAttrName: (name: string) => string;
export declare const defaultOptions: Options;
export declare function computeChildrenFlagForVIf(lastFlag: ChildrenFlags, nextFlag: ChildrenFlags): ChildrenFlags;
export declare function computeChildrenFlagForChildren(lastFlag: ChildrenFlags | null, nextFlag: ChildrenFlags): ChildrenFlags;
export declare function childrenFlagToChildrenType(flag: ChildrenFlags): ChildrenTypes | string;
export declare const helpersMap: {
    _$cv: string;
    _$ce: string;
    _$cc: string;
    _$ct: string;
    _$ccv: string;
    _$cu: string;
    _$le: string;
    _$ma: string;
    _$ex: string;
    _$stm: string;
    _$srm: string;
    _$scm: string;
    _$ssm: string;
    _$isc: string;
    _$cn: string;
    _$su: string;
    _$no: string;
    _$em: string;
};
