import { VNodeComponentClass, IntactDom, TypeDefs } from 'intact';
import { Component } from '../src';
export interface PortalProps {
    container?: Container;
}
export declare type Container = string | ((parentDom: Element, anchor: IntactDom | null) => Element);
export declare class Portal<T extends PortalProps = PortalProps> extends Component<T> {
    static template(this: Portal): import("intact").VNodeTextElement;
    static typeDefs: Required<TypeDefs<PortalProps>>;
    private container;
    mountedQueue?: Function[];
    $isPortal: boolean;
    $render(lastVNode: VNodeComponentClass<this> | null, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[]): void;
    $update(lastVNode: VNodeComponentClass<this>, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[], force: boolean): void;
    $unmount(vNode: VNodeComponentClass<this>, nextVNode: VNodeComponentClass<this> | null): void;
    private initContainer;
}
