import { TransitionElement } from 'misstime';
export declare const enum AnimateType {
    Transition = 0,
    Animation = 1
}
export declare type AnimationInfo = {
    type: AnimateType;
    timeout: number;
    propCount: number;
};
export declare const nodeOps: {
    raf: (fn: () => void) => number;
    caf: (handle: number) => void;
    addClass: (dom: Element, className: string) => void;
    removeClass: (dom: Element, className: string) => void;
};
export declare const TransitionEvents: {
    on: (dom: Element, eventListener: EventListener) => void;
    off: (dom: Element, eventListener: EventListener) => void;
};
export declare function className(obj?: Record<string | number, any> | null | string): string | undefined;
export declare function nextFrame(fn: () => void): () => void;
export declare function whenTransitionEnds(dom: TransitionElement, cb: () => void): void;
export declare function getTransitionInfo(dom: Element): AnimationInfo;
