import { ComponentFunction, TransitionElement } from 'misstime';
import { BaseTransition, BaseTransitionProps } from './baseTransition';
export interface TransitionProps extends BaseTransitionProps {
    name?: string;
    css?: boolean;
    enterFromClass?: string;
    enterActiveClass?: string;
    enterToClass?: string;
    appearFromClass?: string;
    appearActiveClass?: string;
    appearToClass?: string;
    leaveFromClass?: string;
    leaveActiveClass?: string;
    leaveToClass?: string;
}
export declare const Transition: ComponentFunction<TransitionProps, BaseTransition>;
export declare function resolveTransitionProps(props: TransitionProps): BaseTransitionProps;
export declare function addTransitionClass(el: TransitionElement, className: string): void;
export declare function removeTransitionClass(el: TransitionElement, className: string): void;
export declare function forceReflow(): number;
