import { Props } from 'misstime';
import { ChangeCallback, ReceiveCallback } from '../utils/types';
declare type Events<P, E> = {
    [Key in keyof Props<P> as `$change:${string & Key}` | `$changed:${string & Key}`]?: ChangeCallback<Props<P>, Key>[];
} & {
    [Key in keyof Props<P> as `$receive:${string & Key}`]?: ReceiveCallback<Props<P>, Key>[];
} & {
    [Key in keyof E]?: E[Key][];
};
export declare class Event<P extends {}, E extends {}, L extends {}> {
    private $events;
    $blockAddEvent: boolean;
    on<K extends keyof Props<P>>(name: `$receive:${string & K}`, callback: ReceiveCallback<Props<P>, K>): void;
    on<K extends keyof Props<P>>(name: `$change:${string & K}`, callback: ChangeCallback<Props<P>, K>): void;
    on<K extends keyof Props<P>>(name: `$changed:${string & K}`, callback: ChangeCallback<Props<P>, K>): void;
    on<K extends keyof E>(name: K, callback: (...args: E[K] extends any[] ? E[K] : never) => void): void;
    on<K extends keyof L>(name: K, callback: L[K]): void;
    off<K extends keyof Events<P, E>>(name?: K, callback?: Function): void;
    trigger<K extends keyof E>(name: K, ...args: any[] & E[K]): void;
}
export {};
