import type { Component } from '../core/component';
import { VNodeComponentClass, IntactDom } from 'misstime';
import { ChangeTrace } from 'intact-shared';
import { LifecycleEvents } from '../utils/types';
export declare type InternalLifecycleTrigger<K extends keyof LifecycleEvents<T>, T extends Component<any, any>> = (name: K, ...args: Parameters<LifecycleEvents<T>[K]>) => void;
export declare const nextTick: ((callback: Function) => Promise<any>) | ((callback: Function) => number);
export declare function renderSyncComponnet<P>(component: Component<P>, lastVNode: VNodeComponentClass<Component<P>> | null, nextVNode: VNodeComponentClass<Component<P>>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[]): void;
export declare function renderAsyncComponent<P>(component: Component<P>, lastVNode: VNodeComponentClass<Component<P>> | null, nextVNode: VNodeComponentClass<Component<P>>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[]): void;
export declare function updateSyncComponent<P>(component: Component<P>, lastVNode: VNodeComponentClass<Component<P>>, nextVNode: VNodeComponentClass<Component<P>>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[], force: boolean): void;
export declare function updateAsyncComponent<P>(component: Component<P>, lastVNode: VNodeComponentClass<Component<P>>, nextVNode: VNodeComponentClass<Component<P>>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[], force: boolean): void;
export declare function componentInited<P>(component: Component<P>, triggerReceiveEvents: Function | null): void;
export declare function mountProps<P>(component: Component<P>, nextProps: P): () => void;
export declare function patchProps<P>(component: Component<P>, lastProps: P, nextProps: P, defaultProps: Partial<P>): void;
export declare function patchProp<P>(component: Component<P>, props: P, prop: keyof P, lastValue: any, nextValue: any, changeTraces: ChangeTrace[]): void;
export declare function setProps<P>(component: Component<P>, newProps: P): void;
export declare function forceUpdate<P>(component: Component<P>, callback?: Function): void;
export declare function DEV_callMethod(component: Component<any>, method: Function, lastVNode: VNodeComponentClass, nextVNode: VNodeComponentClass): void;
