import { VNodeComponentClass, ComponentClass } from 'misstime';
export declare type SetOptions = {
    silent: boolean;
};
export declare type UnknownKey<T> = Exclude<string, keyof T>;
export declare type WithUnknownKey<T, U> = Partial<T> & U;
export declare type InjectionKey = string | symbol;
export declare type MountLifecycleCallback<T extends ComponentClass> = (lastVNode: VNodeComponentClass<T> | null, nextVNode: VNodeComponentClass<T>) => void;
export declare type UpdateLifecycleCallback<T extends ComponentClass> = (lastVNode: VNodeComponentClass<T>, nextVNode: VNodeComponentClass<T>) => void;
export declare type UnmountLifecycleCallback<T extends ComponentClass> = (lastVNode: VNodeComponentClass<T>, nextVNode: VNodeComponentClass<T> | null) => void;
export declare type LifecycleEvents<T extends ComponentClass> = {
    $inited: () => void;
    $beforeMount: MountLifecycleCallback<T>;
    $mounted: MountLifecycleCallback<T>;
    $beforeUpdate: UpdateLifecycleCallback<T>;
    $updated: UpdateLifecycleCallback<T>;
    $beforeUnmount: UnmountLifecycleCallback<T>;
    $unmounted: UnmountLifecycleCallback<T>;
};
export declare type ChangeCallback<P, K extends keyof P> = (newValue: P[K], oldValue: P[K]) => void;
export declare type ReceiveCallback<P, K extends keyof P> = (newValue: P[K], oldValue: P[K], init: boolean) => void;
export declare type EventCallback = (...args: any[]) => void;
