import { VNodeElement, VNodeTextElement, ComponentConstructor, ComponentFunction, VNode as IVNode, Props, Ref, Key, Children, Types, ChildrenTypes, IntactDom, VNodeTag, VNodeProps, VNodeChildren, VNodeRef, TransitionHooks, TransitionPosition } from '../utils/types';
export declare class VNode<T extends VNodeTag = VNodeTag> implements IVNode<T> {
    dom: IntactDom | null;
    type: Types;
    tag: T;
    childrenType: ChildrenTypes;
    props?: Readonly<VNodeProps<T>> | null;
    children?: VNodeChildren<T> | null;
    className?: string | null;
    key: Key | null;
    ref: VNodeRef<T> | null;
    isValidated?: boolean;
    transition: TransitionHooks | null;
    position: TransitionPosition | null;
    newPosition: TransitionPosition | null;
    constructor(type: Types, tag: T, childrenType: ChildrenTypes, children?: VNodeChildren<T> | null, className?: string | null, props?: VNodeProps<T> | null, key?: Key | null, ref?: VNodeRef<T> | null);
}
export declare function createVNode<T extends VNodeTag>(tag: T, props?: VNodeProps<T> | null, children?: Children | null): VNode<T>;
export declare function getTypeForVNodeElement(tag: string): Types;
export declare function createElementVNode(type: Types, tag: string, children?: Children | null, childrenType?: ChildrenTypes | null, className?: string | null, props?: Props<any, Element> | null, key?: Key | null, ref?: Ref<Element> | null): VNodeElement;
export declare function createComponentVNode<T extends ComponentFunction | ComponentConstructor>(type: Types, tag: T, props: VNodeProps<T> | null, key?: Key | null, ref?: VNodeRef<T> | null): VNode<T>;
export declare function createUnknownComponentVNode<T extends ComponentFunction | ComponentConstructor>(tag: T, props: VNodeProps<T> | null, key?: Key | null, ref?: VNodeRef<T> | null): VNode<T>;
export declare function createTextVNode(text: string | number, key?: Key | null): VNodeTextElement;
export declare function createVoidVNode(): VNodeTextElement;
export declare function createUnescapeTextVNode(text: string | number): VNodeTextElement;
export declare function createCommentVNode(comment: string, key?: Key | null): VNodeTextElement;
export declare function createFragment(children: Children, childrenType: ChildrenTypes, key?: Key | null): VNodeElement;
export declare function directClone<T extends VNode>(vNode: T): T;
export declare function normalizeChildren(vNode: VNode, children: Children): VNode<VNodeTag>;
export declare function normalizeRoot(vNode: Children, parentVNode: VNode): VNode;
