export declare type ChangeTrace = {
    path: string;
    newValue: any;
    oldValue: any;
};
export declare function get<O extends object, K extends keyof O>(object: O, path: K): O[K];
export declare function get<O extends object, K extends string | number | symbol>(object: O, path: K extends keyof O ? never : K): any;
export declare function set<O extends object, K extends keyof O>(object: O, path: K, value: O[K]): ChangeTrace[];
export declare function set<O extends object, K extends string | number | symbol>(object: O, path: K extends keyof O ? never : K, value: any): ChangeTrace[];
